#include <stdio.h>

void main(argc, argv)
int argc;
char *argv[];

{
FILE *f1, *fopen();

if (argc ==1) xdump(stdin);
else {
	if ((f1 = fopen(*++argv,"r")) == -1)
		printf("xdump: can't open %s", argv[1]);
	xdump(f1);
     }
 }

xdump(fp)  /* Dump file */
FILE *fp;
{
int len,i,max;
char data[32];
char array[32];
int offset = 0;

while ((len = read(fp,data,16)) == 16) {
  unpack(&array,16,&data); 
  Tr(&data,16);
  printf("%8.8x   ",offset);
  for (i = 0; i < 32; i++) { 
    printf("%1x",array[i]);
    if (i == 7 || i == 15 || i == 23 || i == 31)
		printf(" ");
  }
  printf("   %16.16s\n",data);
  offset =  offset + 16;
 }

if (len) {
  for (i = 0; i<32; i++) array[i] = 0x20;
  unpack(&array,len,&data);  
  Tr(&data,len);
  printf("%8.8x   ",offset);
  max = len * 2;
  for (i = 0; i < 32; i++) {
    if ( i >= max) printf(" ");
    else     
	printf("%1x",array[i]);
    if (i == 7 || i == 15 || i == 23 || i ==31)
		printf(" ");
  }
  printf("   %-16.16s\n",data);
 } 
}
read(fp,Data,getlen)
FILE *fp;
char Data[];
int  getlen;
{
 int c,i;
        for (i = 0; i < getlen; i++)
  Data[i] = 0x20;
 i = 0;
 while ((c = getc(fp) )  != EOF) {
  Data[i] = c;
  if (i == getlen) {
			Data[i+1] = '\0';
			return(i);
		   }
  i++;
  }
Data[i] = '\0';
return(i);
}
unpack(hex,len,data)
char hex[];
int  len;
char data[];
{
  int c,i;
    
    for (i = 0; i < len; i++) {
	hex[i*2]    = (data[i] & 0xF0) >> 4;
	hex[i*2+1]  = (data[i] & 0x0F);
	}
    hex[i*2] = '\0';
}
Tr(data,len)
char data[];
int len;
{
 int i,c;
    for (i = 0; i < len; i++) {
	c = data[i];
        if (c >= 0 && c <= 37) data[i] = '.';
        else
        if (c >= 177 && c<= 255) data[i] = '.';
	}
}
